:- [tictactoe].
:- [negamax].

aff_charac(A) :-
	var(A),
	write(" ").

aff_charac(A) :-
	ground(A),
	write(A).

aff_lign([A, B, C]) :-
	write("|  "),
	aff_charac(A),
	write("  |  "),
	aff_charac(B),
	write("  |  "),
	aff_charac(C),
	writeln("  |").
	

aff_situation([L1, L2, L3]) :- 
	writeln(""),
	writeln(" _____ _____ _____ "),
	writeln("|     |     |     |"),
	aff_lign(L1),
	writeln("|_____|_____|_____|"),
	writeln("|     |     |     |"),
	aff_lign(L2),
	writeln("|_____|_____|_____|"),
	writeln("|     |     |     |"),
	aff_lign(L3),
	writeln("|_____|_____|_____|"),
	writeln("").

read_coord(L, C) :- 
	writeln("Veuillez saisir la ligne et la colone ou vous voulez jouer."),
	read(L),
	read(C).

coord_ok(Grille, L, C) :-
	number(L),
	number(C),
	L < 4,
	C < 4,
	L > 0,
	C > 0,
	nth1(L, Grille, Ligne),
	nth1(C, Ligne, Valeur),
	var(Valeur).

jouer(Grille, L, C, J) :- 
	nth1(L, Grille, Ligne),
	nth1(C, Ligne, J).


play_local(Grille, J, Prof) :-
	aff_situation(Grille),
	read_coord(L, C),
	(coord_ok(Grille, L, C) ->
		(jouer(Grille, L, C, J),
		adversaire(J, A),
		play_ordi(Grille, A, Prof))
	;
		(writeln("Impossible !"),
		play_local(Grille, J, Prof))
	).

play_ordi(Grille, J, Prof) :-
	negamax(J, Grille, 0, Prof, [Coup, V]),
	(V = 10000 ->
		(Coup = [L, C],
		jouer(Grille, L, C, J),
		write_loose(Grille))
	; 
		(V = -10000 -> 
			write_win(Grille)
		;
			(Coup = nill ->
				write_equality(Grille)
			;
				(Coup = [L, C],
				jouer(Grille, L, C, J),
				adversaire(J, A),
				play_local(Grille, A, Prof))
			)
		)
	).

play(Prof) :- 
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	situation_initiale(I),
	joueur_initial(J),
	play_local(I, J, Prof).

write_loose(Grille) :- 
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	aff_situation(Grille),
	writeln(""),
	writeln("YOU LOST !!!").
	
write_win(Grille) :- 
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	aff_situation(Grille),
	writeln(""),
	writeln("YOU WON !!!").

write_equality(Grille) :- 
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	writeln(""),
	aff_situation(Grille),
	writeln(""),
	writeln("EQUALITY").
